<?php

namespace App\Jobs;

use Illuminate\Bus\Queueable;
use Illuminate\Queue\SerializesModels;
use Illuminate\Queue\InteractsWithQueue;
use Illuminate\Contracts\Queue\ShouldQueue;
use Illuminate\Foundation\Bus\Dispatchable;
use Illuminate\Support\Facades\Mail;
use App\Mail\SendEmailAddPoll;
use App\Managers\User\UserManager;

class LiveProposalEmail implements ShouldQueue
{
    use Dispatchable, InteractsWithQueue, Queueable, SerializesModels;

    /**
     * Create a new job instance.
     *
     * @return void
     */
    public function __construct($users)
    {
        $this->users = $users;
    }

    /**
     * Execute the job.
     *
     * @return void
     */
    public function handle()
    {
        $this->userManager = new UserManager();
        $users = $this->userManager->where('type','general')->where('active', 1)->get();
        $email = new SendEmailAddPoll();
        foreach($users AS $user)
        {
            Mail::send('emails.live-proposal-new', ['email' => $user['email'],'url' => url('/'), 'name' => $user['name']], function ($m) use ($user) {
                $m->from('info@realclubmanager.com', 'SUPPORTER 2.0');
                $m->to($user['email'], $user['name'])->subject('Propunere LIVE noua');
            });
        
            //Mail::to($user['email'])->send($email);
//            Mail::queue('emails.polls-new', ['email' => $user['email'], 'url' => url('/'), 'name' => $user['name']], function ($m) use ($user) {
//                    $m->from('info@rsms.ro', 'RSMS');
//                    $m->to($user['email'], $user['name'])->subject('RSM SOLUTIONS - New Poll Added!');
//                });
        }
    }
}
