<?php

/*
*
* INFOATCLUSTER TECHNOLABS LLP ("COMPANY") CONFIDENTIAL
* Copyright (c) 2016-2017 INFOATCLUSTER TECHNOLABS LLP, All Rights Reserved.
*
* NOTICE:  All information contained herein is, and remains the property of INFOATCLUSTER TECHNOLABS LLP. The intellectual and technical concepts contained
* herein are proprietary to INFOATCLUSTER TECHNOLABS LLP and may be covered by Indian and Foreign Patents, patents in process, and are protected by trade secret or copyright law.
* Dissemination of this information or reproduction of this material is strictly forbidden unless prior written permission is obtained
* from COMPANY.  Access to the source code contained herein is hereby forbidden to anyone except current COMPANY employees, managers or contractors who have executed 
* Confidentiality and Non-disclosure agreements explicitly covering such access.
*
* The copyright notice above does not evidence any actual or intended publication or disclosure  of  this source code, which includes  
* information that is confidential and/or proprietary, and is a trade secret, of  COMPANY.   ANY REPRODUCTION, MODIFICATION, DISTRIBUTION, PUBLIC  PERFORMANCE, 
* OR PUBLIC DISPLAY OF OR THROUGH USE  OF THIS  SOURCE CODE  WITHOUT  THE EXPRESS WRITTEN CONSENT OF COMPANY IS STRICTLY PROHIBITED, AND IN VIOLATION OF APPLICABLE 
* LAWS AND INTERNATIONAL TREATIES.  THE RECEIPT OR POSSESSION OF  THIS SOURCE CODE AND/OR RELATED INFORMATION DOES NOT CONVEY OR IMPLY ANY RIGHTS  
* TO REPRODUCE, DISCLOSE OR DISTRIBUTE ITS CONTENTS, OR TO MANUFACTURE, USE, OR SELL ANYTHING THAT IT  MAY DESCRIBE, IN WHOLE OR IN PART.                
*
*
* @author Mohammed Shayas M K
* 
*/

namespace App\Managers\DecisionPolls;
use App\Managers\DecisionPolls\DecisionPollsModel;
use App\Managers\DecisionPollsOption\DecisionPollsOptionManager;
use Illuminate\Support\Facades\Hash;
use Illuminate\Support\Facades\Session;
use App\Managers\User\UserManager;
use Illuminate\Support\Facades\DB;
use App\Http\Helper\Helper;

class DecisionPollsManager extends DecisionPollsModel
{
    public function __construct()
    {
        $this->decisionPollsOption = new DecisionPollsOptionManager();
        $this->helper = new Helper();
    }

    public function add($data, $userID)
    {
        DB::beginTransaction();
        try 
        {
            /*if($data['default_poll'] == 1)
            {
                $updateArray['default_poll'] = 0;
                $update = $this->where('default_poll', 1)->update($updateArray);
            }*/
            $createdAt = date("Y-m-d H:i:s");
            $options = $data['option'];
            unset($data['option']);
            $data['user_id'] = $userID;
            $data['created_at'] = $data['updated_at'] = $createdAt;
            $data['UUID'] = $this->helper->addUuid();
            $data['expiry_date'] = date("Y-m-d H:i", strtotime($data['expiry_date']));
            $decisionPollsID = $this->insert($data);
            if(!$decisionPollsID)
            {
                return 0;
            }
            
            foreach($options AS $option1)
            {
                $option = array();
                $option['options'] = $option1;
                $option['user_id'] = $userID;
                $option['decision_polls_id'] = $data['UUID'];
                $option['UUID'] = $this->helper->addUuid();
                $option['created_at'] = $option['updated_at'] = $createdAt;
                $optionInsert = $this->decisionPollsOption->insertData($option);
                if(!$optionInsert)
                {
                    return 0;
                }
            }
            
            DB::commit();
            return 1;
        }
        catch(ValidationException $e)
        {
            DB::rollback();
            return 0;
        }
    }
    
    public function updateData($data, $UUID)
    {
        DB::beginTransaction();
        try 
        {
            /*if($data['default_poll'] == 1)
            {
                $updateArray['default_poll'] = 0;
                $update = $this->where('default_poll', 1)->update($updateArray);
            }*/
            $createdAt = date("Y-m-d H:i:s");
//            $options = $data['option'];
            unset($data['option']);
            $data['updated_at'] = $createdAt;
            $data['expiry_date'] = date("Y-m-d H:i", strtotime($data['expiry_date']));
            
            $decisionPollsID = $this->where('UUID', $UUID)->update($data);
            if(!$decisionPollsID)
            {
                return 0;
            }
            
//            foreach($options AS $key => $option1)
//            {
//                $option = array();
//                $option['options'] = $option1;
//                $option['updated_at'] = $createdAt;
//                
//                $optionUpdate = $this->decisionPollsOption->updateData($option, $key);
//                if(!$optionUpdate)
//                {
//                    return 0;
//                }
//            }
            
            DB::commit();
            return 1;
        }
        catch(ValidationException $e)
        {
            DB::rollback();
            return 0;
        }
    }
    
    public function deleteData($UUID)
    {
        DB::beginTransaction();
        try 
        {
            $this->decisionPollsOption->where('decision_polls_id', $UUID)->delete();
            $res = $this->where('UUID', $UUID)->delete();
            if(!$res){
                DB::rollback();
                return 0;
                exit;
            }
            DB::commit();
            return 1;
        }
        catch(ValidationException $e)
        {
            DB::rollback();
            return 0;
            exit;
        }
    }
}