<?php

/*
*
* INFOATCLUSTER TECHNOLABS LLP ("COMPANY") CONFIDENTIAL
* Copyright (c) 2016-2017 INFOATCLUSTER TECHNOLABS LLP, All Rights Reserved.
*
* NOTICE:  All information contained herein is, and remains the property of INFOATCLUSTER TECHNOLABS LLP. The intellectual and technical concepts contained
* herein are proprietary to INFOATCLUSTER TECHNOLABS LLP and may be covered by Indian and Foreign Patents, patents in process, and are protected by trade secret or copyright law.
* Dissemination of this information or reproduction of this material is strictly forbidden unless prior written permission is obtained
* from COMPANY.  Access to the source code contained herein is hereby forbidden to anyone except current COMPANY employees, managers or contractors who have executed 
* Confidentiality and Non-disclosure agreements explicitly covering such access.
*
* The copyright notice above does not evidence any actual or intended publication or disclosure  of  this source code, which includes  
* information that is confidential and/or proprietary, and is a trade secret, of  COMPANY.   ANY REPRODUCTION, MODIFICATION, DISTRIBUTION, PUBLIC  PERFORMANCE, 
* OR PUBLIC DISPLAY OF OR THROUGH USE  OF THIS  SOURCE CODE  WITHOUT  THE EXPRESS WRITTEN CONSENT OF COMPANY IS STRICTLY PROHIBITED, AND IN VIOLATION OF APPLICABLE 
* LAWS AND INTERNATIONAL TREATIES.  THE RECEIPT OR POSSESSION OF  THIS SOURCE CODE AND/OR RELATED INFORMATION DOES NOT CONVEY OR IMPLY ANY RIGHTS  
* TO REPRODUCE, DISCLOSE OR DISTRIBUTE ITS CONTENTS, OR TO MANUFACTURE, USE, OR SELL ANYTHING THAT IT  MAY DESCRIBE, IN WHOLE OR IN PART.                
*
*
* @author Mohammed Shayas M K
* 
*/

namespace App\Managers\PaymentParent;
use App\Managers\PaymentParent\PaymentParentModel;
use App\Managers\User\UserManager;
use App\Managers\Banner\BannerManager;
use Illuminate\Support\Facades\DB;
use App\Http\Helper\Helper;
use Carbon\Carbon;


class PaymentParentManager extends PaymentParentModel
{
    public function __construct()
    {
        $this->user = new UserManager();
        $this->bannerManager = new BannerManager();
        $this->helper = new Helper();
    }

    public function add($data1)
    {
        $data = array();
        $data['uuid'] = $this->helper->addUuid();
        $data['expiry_date'] = $data1['expiry_date'];
        $data['no_of_votes'] = $data1['no_of_votes'];
        if(isset($data1['faulty']))
        {
            $data['faulty'] = $data1['faulty'];
        }
        $data['user_id'] = $data1['user_id'];
        
        $requiredFields = array('mc_gross', 'protection_eligibility','address_status','payer_id',
            'tax',
            'address_street',
            'payment_date',
            'payment_status' ,
            'charset',
            'address_zip' ,
            'first_name' ,
            'mc_fee' ,
            'address_country_code' ,
            'address_name' ,
            'notify_version' ,
            'custom' ,
            'payer_status' ,
            'business' ,
            'address_country' ,
            'address_city' ,
            'quantity' ,
            'verify_sign' ,
            'payer_email' ,
            'txn_id' ,
            'payment_type' ,
            'payer_business_name' ,
            'last_name' ,
            'address_state' ,
            'receiver_email' ,
            'payment_fee' ,
            'receiver_id' ,
            'txn_type' ,
            'item_name' ,
            'mc_currency' ,
            'item_number' ,
            'residence_country' ,
            'test_ipn' ,
            'transaction_subject' ,
            'payment_gross' ,
            'ipn_track_id' ,
            'memo');
        
        foreach($requiredFields AS $value)
        {
            if(isset($data1[$value]))
            {
                $data[$value] = $data1[$value];
            }
        }
        
        $createdAt = $data['created_at'] = $data['updated_at'] = date("Y-m-d H:i:s");
        DB::beginTransaction();
        try 
        {
            $playerID = $this->insert($data);
            if(!$playerID)
            {
                return 0;
            }
            
            if($data['no_of_votes'] >= 1 && !isset($data['faulty']))
            {
                $this->user->where('UUID', $data['user_id'])->update(array('member' => 1));
            }
            DB::commit();
            return 1;
        }
        catch(ValidationException $e)
        {
            DB::rollback();
            return 0;
        }
    }
    
    public function insertMobilPay($data)
    {
        
        $data['uuid'] = $this->helper->addUuid();
       
        
        $requiredFields = array('error_message', 'payment_status','mc_currency','type',
            'mc_gross',
            'no_of_votes',
            'payment_date',
            'expiry_date' ,
            'user_id',
            'details' ,
            'first_name' ,
            'payer_email' ,
            'payer_phone' ,
            'address_street' ,
            'txn_id');
        
//        foreach($requiredFields AS $value)
//        {
//            if(isset($data1[$value]))
//            {
//                $data[$value] = $data1[$value];
//            }
//        }
//        
        $createdAt = $data['created_at'] = $data['updated_at'] = date("Y-m-d H:i:s");
        DB::beginTransaction();
        try 
        {
            $playerID = $this->insert($data);
            if(!$playerID)
            {
                return 0;
            }
            
            if($data['no_of_votes'] >= 1 && !isset($data['faulty']))
            {
                $this->user->where('UUID', $data['user_id'])->update(array('member' => 1));
            }
            DB::commit();
            return 1;
        }
        catch(ValidationException $e)
        {
            DB::rollback();
            return 0;
        }
    }
    
    public function insertBannerPayment($data, $bannerContainerID)
    {
        $data['uuid'] = $this->helper->addUuid();
        $requiredFields = array('error_message', 'payment_status','mc_currency','type',
            'mc_gross',
            'no_of_votes',
            'payment_date',
            'expiry_date' ,
            'user_id',
            'details' ,
            'first_name' ,
            'payer_email' ,
            'payer_phone' ,
            'address_street' ,
            'txn_id');
        
        
        
        $createdAt = $data['created_at'] = $data['updated_at'] = date("Y-m-d H:i:s");
        DB::beginTransaction();
        try 
        {
            $paypalID = $this->insert($data);
            if(!$paypalID)
            {
                return 0;
                exit;
            }
            
            $updateData['paypal_id'] = $paypalID;
            $bannerContainerUpdate = $this->bannerManager->where('banner_container_id', $bannerContainerID)->update($updateData);
            if(!$bannerContainerUpdate)
            {
                return 0;
                exit;
            }
            
            DB::commit();
            return 1;
        }
        catch(ValidationException $e)
        {
            DB::rollback();
            return 0;
        }
    }
    
    public function getTotalVotesCount()
    {
        return $this->select(DB::raw('(SUM(no_of_votes)) AS total'))->whereDate('expiry_date', '>=', Carbon::now())->first();
    }
    
    public function getCurrentUserTotalVotesCount($userID)
    {
        return $this->select(DB::raw('(SUM(no_of_votes)) AS total'))->whereDate('expiry_date', '>=', Carbon::now())->whereRaw('`no_of_votes` > `used_votes`')->where('user_id', $userID)->first();
    }
    
    public function getAllCreditsOfUser($userID)
    {
        return $this->select('*', DB::raw('DATE_FORMAT(expiry_date, "%d %M %Y") AS expiry_date_formatted'), DB::raw('DATE_FORMAT(payment_date, "%d %M %Y  %H:%i") AS payment_date_formatted'), DB::raw('DATE_FORMAT(created_at, "%d %M %Y %H:%i") AS created_at_formatted'))->where('user_id', $userID)->whereDate('expiry_date', '>=', Carbon::now())->whereRaw('`no_of_votes` > `used_votes`')->orderBy('created_at', 'ASC')->get();
    }
    
    public function addVotes($data, $userID)
    {
        DB::beginTransaction();
        try 
        {
            if(!empty($data['votes']))
            foreach($data['votes'] AS $each)
            {
                if(trim($each['no_of_votes']) != '' && is_numeric($each['no_of_votes']) && trim($each['expiry_date']) != '' && trim($each['payment_date']) != '')
                {
                    $insert = array();
                    $insert = $each;
                    $insert['UUID'] = $this->helper->addUuid();
                    $insert['expiry_date'] = date("Y-m-d", strtotime($each['expiry_date']));
                    $insert['payment_date'] = date("Y-m-d H:i:s", strtotime($each['payment_date']));
                    
                    $insert['mc_gross'] = $insert['payment_gross'] = $each['price'];
                    $insert['user_id'] = $userID;
                    $insert['created_at'] = $insert['updated_at'] = date("Y-m-d H:i:s");
                    $insert['type'] = 'Admin';
                    unset($insert['price']);
                    $res = $this->insert($insert);
                    if(!$res)
                    {
                        return 0;
                        exit;
                    }
                }
            }
            DB::commit();
            return 1;
        }
        catch(ValidationException $e)
        {
            DB::rollback();
            return 0;
        }
    }
}