<?php

use Illuminate\Support\Facades\Schema;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Database\Migrations\Migration;

class CreateEmailTable extends Migration
{
    /**
     * Run the migrations.
     *
     * @return void
     */
    public function up()
    {
        Schema::create('email', function (Blueprint $table) {
            $table->bigIncrements('id');
            $table->uuid('UUID')->unique();
            $table->string('subject')->nullable();
            $table->text('email')->nullable();
            
            $table->string('cc')->nullable();
            $table->string('bcc')->nullable();
            $table->text('body')->nullable();
            $table->uuid('user_id', 255);
            $table->timestamps();
            
            $table->softDeletes();
            
            $table->foreign('user_id')->references('UUID')->on('users');
        });
    }

    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down()
    {
        Schema::dropIfExists('email');
    }
}
